/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.wahlrechtspruefung;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.wahlrechtspruefung.boundary.AbstractPruefkriteriumSearchParameters;
import de.ivu.elect.business.wahlrechtspruefung.boundary.PruefkriteriumChangeEvent;
import de.ivu.elect.business.wahlrechtspruefung.boundary.PruefkriteriumConversationStore;
import de.ivu.elect.business.wahlrechtspruefung.boundary.PruefkriteriumExtendedDAO;
import de.ivu.elect.business.wahlrechtspruefung.boundary.PruefkriteriumSearch;
import de.ivu.elect.business.wahlrechtspruefung.boundary.PruefkriteriumSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.wahlrechtspruefung.entity.Pruefkriterium;
import de.ivu.elect.business.wahlrechtspruefung.entity.PruefkriteriumMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractPruefkriteriumSearchView.COMPONENT_NAME)
@View(viewId = AbstractPruefkriteriumSearchView.VIEW_ID, useCase = UseCasePermission.PRUEFKRITERIUM_SEARCH)
public abstract class AbstractPruefkriteriumSearchView extends AbstractElectSearchView<Pruefkriterium> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "pruefkriteriumSearchView";
  
  public static final String VIEW_ID = "/wahlrechtspruefung/pruefkriterium-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractPruefkriteriumSearchView requestHandler;

  @Inject
  private transient PruefkriteriumExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(PruefkriteriumConversationStore.class)
  protected transient PruefkriteriumConversationStore conversationStore;

  @Inject
  protected transient PruefkriteriumSearch search;

  @Inject
  @ConversationGroup(AbstractPruefkriteriumSearchParameters.class)
  protected transient PruefkriteriumSearchParameters searchParameters;

  @Inject
  protected transient PruefkriteriumMeta entityMeta;

  public AbstractPruefkriteriumSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public Pruefkriterium getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(Pruefkriterium entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public PruefkriteriumSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<Pruefkriterium> getEagerLoadingCollector() {
    return EagerLoadingCollector.<Pruefkriterium> create();
  }

  @Override
  public List<Pruefkriterium> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<Pruefkriterium> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onPruefkriteriumChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) PruefkriteriumChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  //  Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractPruefkriteriumSearchView {

    @View
    @Inject
    private transient Instance<AbstractPruefkriteriumSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractPruefkriteriumSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
